#pragma semicolon 1

#include <sourcemod>
#include <knife_arena>
#include <vip>

public Plugin:myinfo = 
{
	name	= "Disable VIP On Arena",
	author	= "wS",
	version = "1.0"
};

new bool:g_bVipOnArena[MAXPLAYERS + 1];
public OnClientDisconnect(client) g_bVipOnArena[client] = false;

public OnPluginStart()
{
	KA_HookEvent(KA_Event:KA_OnPushFromQueueToArenaPost,	OnPushFromQueueToArenaPost);
	KA_HookEvent(KA_Event:KA_OnArenaClientRemoved,			OnArenaClientRemoved);
	
	HookEvent("round_end",   round, EventHookMode_PostNoCopy);
	HookEvent("round_start", round, EventHookMode_PostNoCopy);
}

public OnPushFromQueueToArenaPost(client)
{
	if (VIP_GetFlags(client) & VCF_VIP)
	{
		g_bVipOnArena[client] = true;
		SetVip(client, 0);
	}
}

public OnArenaClientRemoved(client, KA_Reason:reason)
{
	if (reason != KA_Disconnect)
		ReturnVip(client);
}

public round(Handle:event, const String:name[], bool:silent)
{
	for (new i = 1; i <= MaxClients; i++)
		ReturnVip(i);
}

ReturnVip(client)
{
	if (g_bVipOnArena[client])
	{
		g_bVipOnArena[client] = false;
		if (VIP_GetFlags(client) & VCF_VIP) SetVip(client, 1);
	}
}

SetVip(client, vip)
{
	ServerCommand("sm_vipsetitemstatus all %d %d", vip, GetClientUserId(client));
}